include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
include "nat.ma".
axiom gcd_aux : nat -> nat -> nat -> nat.
axiom gcd_aux_body : nat -> nat -> nat -> nat.
axiom axiom_gcd_aux : \forall (p:nat). (equal) (nat -> nat -> nat) ((gcd_aux)  p) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p).
definition eq_gcd_aux : \forall (p:nat). (leibniz) (nat -> nat -> nat) ((gcd_aux)  p) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p) := \lambda p : nat. ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux)  p)) ((filter_nat_type) (nat -> nat -> nat) (gcd_aux_body)  p)) ((axiom_gcd_aux) (p)).
axiom axiom_gcd_aux_body_O : (equal) (nat -> nat -> nat) ((gcd_aux_body)  (O) ) (\lambda m : nat. \lambda n : nat. m).
definition eq_gcd_aux_body_O : (leibniz) (nat -> nat -> nat) ((gcd_aux_body)  (O) ) (\lambda m : nat. \lambda n : nat. m) := ((((equal_leibniz) (nat -> nat -> nat)) ((gcd_aux_body)  (O) )) (\lambda m : nat. \lambda n : nat. m)) (axiom_gcd_aux_body_O).
definition gcd : nat -> nat -> nat := \lambda n : nat. \lambda m : nat. (match_bool_type) (nat) ((gcd_aux)  n m n) ((gcd_aux)  m n m) ((leb)  n m).
definition gcd_O_l : \forall (m:nat). (eq) (nat) ((gcd)  (O)  m) m := \lambda m : nat. (((((eq_match_bool_type_true) (nat)) (m)) ((gcd_aux)  m (O)  m)) (\lambda y : nat. (eq) (nat) ((gcd)  (O)  m) y)) (((eq_leb_body_O) (\lambda y : nat -> bool. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) (((((eq_filter_nat_type_O) (nat -> bool)) ((leb_body) )) (\lambda y : nat -> bool. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) ((((eq_leb) ((O) )) (\lambda y : nat -> bool. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) m ((gcd_aux)  m (O)  m) (y m)))) (((eq_gcd_aux_body_O) (\lambda y : nat -> nat -> nat. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) (((((eq_filter_nat_type_O) (nat -> nat -> nat)) ((gcd_aux_body) )) (\lambda y : nat -> nat -> nat. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) ((((eq_gcd_aux) ((O) )) (\lambda y : nat -> nat -> nat. (eq) (nat) ((gcd)  (O)  m) ((match_bool_type) (nat) (y m (O) ) ((gcd_aux)  m (O)  m) ((leb)  (O)  m)))) (((refl) (nat)) ((gcd)  (O)  m)))))))).
